import tensorflow as tf

class SamplingLayer(tf.keras.layers.Layer):
    def __init__(self, **kwargs):
        super(SamplingLayer, self).__init__(**kwargs) 
        
    def get_vars(self):
        return self.var1

    def build(self, input_shape):
        initializer = tf.keras.initializers.Ones()
        self.var1 = self.add_weight(shape=(input_shape[1],input_shape[2]), initializer=initializer, regularizer=tf.keras.regularizers.L1(1), trainable=True, name='weights')
        super(SamplingLayer, self).build(input_shape)  
    
    def call(self, inputs):
        y_pred = tf.math.multiply(inputs, self.var1)
        return y_pred

    def compute_output_shape(self, input_shape):
        return input_shape
    
    def get_config(self):
        config = super(SamplingLayer, self).get_config()
        config.update({"var1": self.var1.numpy()})
        return config